// Copyright (c) 2017 Shian-Yu Liao. All rights reserved.
// This file simulates "Durable Goods, Investment Shocks and the Comovement Problem"
 
var xi TobinQ xi_d eps_R Ac Ad t psi_b p q gam V w mk_c mk_d zet_s kap APL APLc APLd MPKc MPKd MPLc MPLd R I K Kc Kd X Xs Y Yc Yd C Cs Cb DI DIs D Ds Db bs bb L Ls Lc Ld pi pi_c pi_d f Zs MUCs MULs MUDs adj_k adj_k_1 adj_k_2 adj_ds adj_ds_1 adj_ds_2;
varexo eps_xi eps_xi_d u;
parameters xiss xi_dss Acss Adss thet_c_Calvo thet_d_Calvo thet_c thet_d ela_c ela_d bet_s bet_b eta alph_c alph_d mu nu_s phi delt delt_k m_b phi_k phi_ds rho_R rho_c rho_d rho_xi rho_xi_d sigm_xi phi_pi tss mk_css mk_dss Rss pss wss psi_bss Dbss Cbss bbss kap_c kap_d ups_11 ups_12 ups_13 ups_21 ups_22 ups_23 ups_c1 ups_d1 ups_c2 ups_d2 Ydss Ycss Lss Lcss Ldss Dsss Csss Lsss bsss Css Dss Zsss;
 
thet_c_Calvo = 0.8;
thet_d_Calvo = 0;
ela_c = 6;
ela_d = 6;
bet_s = 0.99;
bet_b = 0.98;
thet_c = thet_c_Calvo*(ela_c-1)/((1-thet_c_Calvo)*(1-bet_s*thet_c_Calvo));
thet_d = thet_d_Calvo*(ela_d-1)/((1-thet_d_Calvo)*(1-bet_s*thet_d_Calvo));
eta = 1;
mu = 0.2;
phi = 1;
Acss = 1;
Adss = 1;
xiss = 1;
xi_dss = 1;
alph_c = 0.47;
alph_d = 0.27;
delt = 0.025;
delt_k = 0.025;
m_b = 0;
phi_k = 0.005;
phi_ds = 0;
rho_R = 0.5;
rho_c = 0.999999;
rho_d = 0.999999;
rho_xi = 0.72;
rho_xi_d = 0.928;
sigm_xi = 0.0603;
phi_pi = 1.5;
tss = 0;
Lsss = 1/3;
mk_css = 1-1/ela_c;
mk_dss = 1-1/ela_d;
Rss=1/bet_s;
pss=((1/bet_s-(1-delt_k))^(alph_c/(1-alph_c)-alph_d/(1-alph_d))*mk_dss*(1-alph_d)*Adss/(mk_css*(1-alph_c)*Acss)*(1/(mk_dss*alph_d*Adss))^(-alph_d/(1-alph_d))*(1/(mk_css*alph_c*Acss))^(alph_c/(1-alph_c)))^-(1-alph_c);
qss=(1/bet_s-(1-delt_k))*pss;
wss=pss*mk_dss*(1-alph_d)*Adss*(qss/(pss*mk_dss*alph_d*Adss))^(-alph_d/(1-alph_d));
kap_c=1/qss*mk_css*alph_c;
kap_d=pss/qss*mk_dss*alph_d;
psi_bss=0;
Dbss=0;
Cbss=0;
bbss=0;
bsss=0;
ups_11=(1-mk_css*(1-alph_c)-pss*delt_k*kap_c)/((pss-pss*bet_s*(1-delt))^eta*(1-mu)/mu+pss*delt);
ups_12=(pss-pss*mk_dss*(1-alph_d)-pss*delt_k*kap_d)/((pss-pss*bet_s*(1-delt))^eta*(1-mu)/mu+pss*delt);
ups_13=((Rss-1)*bsss+wss*Lsss+tss)/((pss-pss*bet_s*(1-delt))^eta*(1-mu)/mu+pss*delt);
ups_21=(pss-pss*bet_s*(1-delt))^eta*(1-mk_css*(1-alph_c)-pss*delt_k*kap_c)*(1-mu)/mu/((pss-pss*bet_s*(1-delt))^eta*(1-mu)/mu+pss*delt);
ups_22=(pss-pss*bet_s*(1-delt))^eta*(pss-pss*mk_dss*(1-alph_d)-pss*delt_k*kap_d)*(1-mu)/mu/((pss-pss*bet_s*(1-delt))^eta*(1-mu)/mu+pss*delt);
ups_23=(pss-pss*bet_s*(1-delt))^eta*((Rss-1)*bsss+wss*Lsss+tss)*(1-mu)/mu/((pss-pss*bet_s*(1-delt))^eta*(1-mu)/mu+pss*delt);
ups_c1=0;
ups_d1=0;
ups_c2=0;
ups_d2=0;
Ydss=((delt*ups_11+delt_k*kap_c)*(ups_23+Cbss)/(1-ups_21)+delt*ups_13+delt*Dbss)/(1-delt*ups_12-delt_k*kap_d-(delt*ups_11+delt_k*kap_c)*ups_22/(1-ups_21));
Ycss=(ups_22+ups_d1)*Ydss/(1-ups_21-ups_c1)+(ups_23+Cbss)/(1-ups_21-ups_c1);
Lcss=(1/wss)*mk_css*(1-alph_c)*Ycss;
Dsss=ups_11*Ycss+ups_12*Ydss+ups_13;
Csss=(pss-bet_s*pss*(1-delt))^eta*Dsss*(1-mu)/mu;
Ldss=Lsss-Lcss;
Css=Csss+Cbss;
Dss=Dsss+Dbss;
Zsss=pss-bet_s*(1-delt)*pss;
nu_s=wss/(Lsss^phi*Csss*(1+(mu/(1-mu))^(1/eta)*(Dsss/Csss)^((eta-1)/eta))); 
Kcss=1/qss*mk_css*alph_c*Ycss;
Kdss=pss/qss*mk_dss*alph_d*Ydss;
Kss=Kcss+Kdss;
Lss=Lsss;
 
model;
MUCs=1/(Cs*(1+(mu/(1-mu))^(1/eta)*(Ds/Cs)^((eta-1)/eta)));
MULs=-nu_s*Ls^phi; 
MUDs=1/(Ds*(1+((1-mu)/mu)^(1/eta)*(Cs/Ds)^((eta-1)/eta)));
adj_k=phi_k/2*(I/I(-1)-1)^2;
adj_k_1=phi_k*(I/I(-1)-1);
adj_k_2=phi_k*(I(+1)/I-1);
adj_ds=phi_ds/2*(DIs/DIs(-1)-1)^2;
adj_ds_1=phi_ds*(DIs/DIs(-1)-1);
adj_ds_2=phi_ds*(DIs(+1)/DIs-1);
Yc=Acss*Kc^alph_c*Lc^(1-alph_c);
MULs/MUCs=-w;
MUCs-bet_s*MUCs(+1)*R/pi_c(+1)=0;
-kap*p+bet_s*(MUCs(+1)*q(+1)+kap(+1)*p(+1)*(1-delt_k))=0;
-p*MUCs+kap*p*xi*(1-adj_k-adj_k_1*I/I(-1))+bet_s*kap(+1)*p(+1)*xi(+1)*(I(+1)/I)^2*adj_k_2=0;
MUDs-zet_s*p+bet_s*zet_s(+1)*p(+1)*(1-delt)=0; 
-p*MUCs+zet_s*p*xi_d*(1-adj_ds-adj_ds_1*DIs/DIs(-1))+bet_s*zet_s(+1)*p(+1)*xi_d(+1)*(DIs(+1)/DIs)^2*adj_ds_2=0;
Ds-(1-delt)*Ds(-1)=xi_d*(1-adj_ds)*DIs;
K-(1-delt_k)*K(-1)=xi*(1-adj_k)*I;
f=(Yc-w*Lc-q*Kc-thet_c/2*(pi_c-1)^2*Yc)+(p*Yd-w*Ld-q*Kd-thet_d/2*(pi_d-1)^2*p*Yd);
Cb=0; 
Db=0;
bb=0; 
psi_b=0;
mk_c*(1-alph_c)*Yc/Lc=w;
p*mk_d*(1-alph_d)*Yd/Ld=w;
mk_c*alph_c*Yc/Kc=q;
p*mk_d*alph_d*Yd/Kd=q;
K(-1)=Kc+Kd;
Yd=Adss*Kd^alph_d*Ld^(1-alph_d);
(1-ela_c*(1-mk_c)-thet_c*(pi_c-1)*pi_c)*Yc+bet_s*MUCs(+1)/MUCs*(thet_c*(pi_c(+1)-1)*pi_c(+1)^2/pi_c(+1)*Yc(+1))=0;
(1-ela_d*(1-mk_d)-thet_d*(pi_d-1)*pi_d)*Yd+bet_s*MUCs(+1)/MUCs*(thet_d*(pi_d(+1)-1)*pi_d(+1)^2/pi_c(+1)*Yd(+1))=0;
Yc=C+thet_c/2*(pi_c-1)^2*Yc;
Yd=DI+I+thet_d/2*(pi_d-1)^2*Yd;
C=Cs+Cb;
D=Ds+Db;
bs=0;
t=0;
Lc+Ld=Ls;
Ac=Ac(-1)^rho_c;
Ad=Ad(-1)^rho_d;
R/Rss=pi^phi_pi*exp(eps_R);
pi=pi_c^(1-mu)*pi_d^mu;
pi_d=p/p(-1)*pi_c;
exp(eps_R)=exp(eps_R(-1))^rho_R*u;
DI=DIs;
Zs=p-bet_s*(1-delt)*(MUCs(+1)/MUCs*p(+1));
Y=Yc+p*Yd;
Xs=Cs^(1-mu)*Ds^mu;
X=C+p*DI;
gam=q/p;
V=p*MUCs;
L=Ls;
MPKc=q/mk_c;
MPKd=q/(p*mk_d);
MPLc=w/mk_c;
MPLd=w/(p*mk_d);
APL=Y/L;
APLc=Yc/Lc;
APLd=Yd/Ld;
TobinQ=1/xi;
xi=xi(-1)^rho_xi*exp(eps_xi);
xi_d=xi_d(-1)^rho_xi_d*exp(eps_xi_d);
end;
 
initval;
 
Ac=Acss;
Ad=Adss;
psi_b=psi_bss;
p=pss;
w=wss;
q=qss;
mk_c=mk_css;
mk_d=mk_dss;
R=Rss;
Yc=Ycss;
Yd=Ydss;
C=Css;
Cs=Csss;
Cb=Cbss;
D=Dss;
Ds=Dsss;
Db=Dbss;
bs=bsss;
bb=bbss;
Ls=Lsss;
Lc=Lcss;
Ld=Ldss;
pi=1;
pi_c=1;
pi_d=1;
f=(1-mk_css*(1-alph_c)-qss*kap_c)*Ycss+(pss-pss*mk_dss*(1-alph_d)-qss*kap_d)*Ydss;
DI=Ydss-delt_k*Kss;
eps_R=0;
MUCs=1/(Csss*(1+(mu/(1-mu))^(1/eta)*(Dsss/Csss)^((eta-1)/eta))); 
MULs=-nu_s*Lsss^phi; 
MUDs=1/(Dsss*(1+((1-mu)/mu)^(1/eta)*(Csss/Dsss)^((eta-1)/eta)));
Zs=Zsss;
Y=Ycss+pss*Ydss;
Xs=Csss^(1-mu)*Dsss^mu;
X=Css+pss*(Ydss-delt_k*Kss);
Kc=Kcss;
Kd=Kdss;
K=Kss;
I=delt_k*Kss;
gam=1/bet_s-(1-delt_k);
V=pss*1/(Csss*(1+(mu/(1-mu))^(1/eta)*(Dsss/Csss)^((eta-1)/eta)));
L=Lss;
MPKc=qss/mk_css;
MPKd=qss/(pss*mk_dss);
MPLc=wss/mk_css;
MPLd=wss/(pss*mk_dss);
adj_k=0;
adj_k_1=0;
adj_k_2=0;
adj_ds=0;
adj_ds_1=0;
adj_ds_2=0;
u=1;
zet_s=1/(Csss*(1+(mu/(1-mu))^(1/eta)*(Dsss/Csss)^((eta-1)/eta)))/xi_dss;
kap=1/(Csss*(1+(mu/(1-mu))^(1/eta)*(Dsss/Csss)^((eta-1)/eta)))/xiss;
DIs=delt*Dsss;
t=tss;
xi=xiss;
xi_d=xi_dss;
eps_xi=0;
eps_xi_d=0;
APL=(Ycss+pss*Ydss)/Lss;
APLc=Ycss/Lcss;
APLd=Ydss/Ldss;
TobinQ=1/xiss;
end;
 
resid(1);
 
steady;
check;
shocks;
var eps_xi = sigm_xi^2;
end;
 
stoch_simul(order=1,irf=15) TobinQ R p pi q w mk_c mk_d K C D DI V I MPLc MPLd MPKc MPKd L f X Y Yc Yd Lc Ld Kc Kd APL APLc APLd;


